﻿/*
 *Copyright(C) 2020 by  Cyf All rights reserved.
 *Unity版本：2021.3.11f1c2 
 *作者:程一峰  
 *创建日期: 2022-11-10 
 *模块说明：木蝴蝶数学库：计算结果
 *版本: 1.0
*/

using Unity.Mathematics;

namespace Oroxylum
{
    /// <summary>
    /// 计算结果：3d直线与线段
    /// </summary>
    public struct IntrLine3dPlane
    {

        public E_IntersectionResult Result;
        public E_IntersectionType Type;
        public float3 CastPoint;

        public IntrLine3dPlane(Line3d line, Plane3d plane)
        {
            Result = E_IntersectionResult.NotComputed;

            float d1 = math.dot(plane.PlanePoint - line.Origin, plane.Normal);
            float d2 = math.dot(line.Direction, plane.Normal);
            if (d2 == 0)
            {
                float distance = plane.GetDistanceToPoint(line.Origin);
                if (distance <= OMath.ZeroTolerance)
                {
                    //直线就在平面上；
                    Type = E_IntersectionType.Line;
                    Result = E_IntersectionResult.NotComputed;
                    CastPoint = line.Origin;
                }
                else
                {
                    //此时直线与平面平行；
                    Type = E_IntersectionType.Empty;
                    Result = E_IntersectionResult.NoIntersection;
                    CastPoint = float.MaxValue;
                }
                return;
            }

            Type = E_IntersectionType.Point;
            Result = E_IntersectionResult.Intersects;
            CastPoint = (d1 / d2 * line.Direction) + line.Origin;
        }


    }
}