﻿/*
 *Copyright(C) 2020 by  Cyf All rights reserved.
 *Unity版本：2021.3.11f1c2 
 *作者:程一峰  
 *创建日期: 2022-11-10 
 *模块说明：木蝴蝶数学库：数据格式
 *版本: 1.0
*/

using Unity.Mathematics;

namespace Oroxylum
{
    /// <summary>
    /// 2d Box
    /// 平行四边形
    /// </summary>
    public struct Box2d
    {
        // A box has center C, axis directions U[0] and U[1] (perpendicular and
        // unit-length vectors), and extents e[0] and e[1] (nonnegative numbers).
        // A/ point X = C+y[0]*U[0]+y[1]*U[1] is inside or on the box whenever
        // |y[i]| <= e[i] for all i.

        public float2 Center;
        public float2 Extent;

        public float2 AxisX;
        public float2 AxisY;

        public Box2d(float2 center, float2 extent)
        {
            Center = center;
            Extent = extent;
            AxisX = OMath.AxisX_2d;
            AxisY = OMath.AxisY_2d;
        }

    }
}