﻿/*
 *Copyright(C) 2020 by  Cyf All rights reserved.
 *Unity版本：2021.3.11f1c2 
 *作者:程一峰  
 *创建日期: 2022-11-10 
 *模块说明：木蝴蝶数学库：数据格式
 *版本: 1.0
*/

using Unity.Mathematics;

namespace Oroxylum
{
    /// <summary>
    /// AxisAlignedBox2d
    /// 规整的AABB盒子
    /// </summary>
    public struct Box2dAABB
    {

        public float2 Min;
        public float2 Max;

        public Box2dAABB(float2 vMin, float2 vMax)
        {
            Min = new float2(math.min(vMin.x, vMax.x), math.min(vMin.y, vMax.y));
            Max = new float2(math.max(vMin.x, vMax.x), math.max(vMin.y, vMax.y));
        }

        public float Width => math.max(Max.x - Min.x, 0);
        public float Height => math.max(Max.y - Min.y, 0);
        /// <summary>
        /// 面积
        /// </summary>
        public float Volume => Width * Height;

        public float2 Diagonal => new float2(Max.x - Min.x, Max.y - Min.y);
        public float2 Extents => new float2((Max.x - Min.x) * 0.5f, (Max.y - Min.y) * 0.5f);
        public float2 Center => new float2((Min.x + Max.x) * 0.5f, (Min.y + Max.y) * 0.5f);

    }
}